<template>
    <q-page class="bg-base">
        <DocumentWrapper ref="wrap">
            <Container :max-height="1" class="full-width column ">
                <WorkerChart :floor="Floor" ref='Chart' v-if="Opts != null"
                             class="col q-pa-sm" style="box-sizing: border-box"
                             :settings="GraphSettings.StoreValue" :options="Opts" :days="days"/>
                <q-skeleton v-else type="rect" class="full-width col"/>
                <q-separator/>
                <div class="row justify-evenly q-pa-sm">
                    <q-btn flat @click="dialog = true">Change Graph</q-btn>
                    <q-btn flat color="primary" @click="CreateWidget">Add Widget</q-btn>
                </div>

            </Container>
        </DocumentWrapper>

        <q-dialog persistent v-model="createDialog">
            <div class="bg-base q-pa-lg">
                <AddWidgetDialog @create="AddWidget" @back="createDialog = false"/>
            </div>
        </q-dialog>
        <q-dialog persistent v-model="dialog" position="bottom" style="max-width: 800px; width: 100%">
            <div class="bg-base q-pa-lg full-width q-gutter-y-lg">
                <div class="row justify-between">
                    <q-btn primary icon="clear" color="primary" @click="dialog = false" label="close"/>
                </div>
                <WorkerChartOptionsWidget v-model="rawOptions" :days="days"/>
                <TimeQueryPicker v-model="time" :all="false"/>
            </div>
        </q-dialog>
    </q-page>
</template>

<script lang='ts'>
import {Component, Vue, Watch} from 'vue-property-decorator';
import DocumentWrapper from "components/Core/DocumentWrapper.vue";
import Container from "components/Core/Container.vue";
import WorkerChart from "components/Charts/WorkerChart.vue";
import WorkerChartOptionsWidget from "components/Charts/WorkerChartOptionsWidget.vue";
import {ChartWidget, RelativeTimeConfig, Widget, WidgetData} from "src/classLibrary/Dashboard/Dashboard";
import TimeQueryPicker from "pages/Widget/TimeQueryPicker.vue";
import {ToStartEnd} from "src/classLibrary/Dashboard/DashboardUtility";
import {FloorPrincipalResponse} from "src/classLibrary/APIModels/core/floorPrincipalResponse";
import {WorkerGraphOption, WorkerGraphOptionBase} from "src/classLibrary/Charting/WorkerChart";
import {format} from "date-fns";
import {IWidgetStore, ServerWidgetStore} from "src/classLibrary/Dashboard/WidgetStore";
import AddWidgetDialog from "components/Dialog/AddWidgetDialog.vue";
import {uid} from "quasar";
import {WorkerChartWidget} from "src/classLibrary/Dashboard/WorkerChartWidget";
import {DeepClone, WarnMessage} from "src/classLibrary/Utility";

@Component({
    components: {AddWidgetDialog, TimeQueryPicker, WorkerChartOptionsWidget, WorkerChart, Container, DocumentWrapper}
})
export default class WorkerChartType extends Vue {

    dialog = false;
    createDialog = false;
    rawOptions = {
        subId: '',
        workerId: '',
        merge: true,
        type: '',
        floorId: '',
        specifyFloor: false,
    }

    widgetStore: IWidgetStore = new ServerWidgetStore(this.$coreApi, this.$auth, this.PersistentStore.StoreValue.project);

    time: RelativeTimeConfig = {start: 0, amount: 1};

    floors: FloorPrincipalResponse[] = [];

    options: WorkerGraphOptionBase | null = null

    @Watch('rawOptions')
    OnRawOptionsChange() {
        const projectId = this.PersistentStore.StoreValue.project;
        this.options = {
            workerId: this.rawOptions.workerId,
            floorId: this.rawOptions.specifyFloor ? this.rawOptions.floorId : undefined,
            merge: this.rawOptions.merge,
            projectId,
            range: true,
            subId: this.rawOptions.subId,
            type: this.rawOptions.type as any,
        }
        if (this.options.workerId != '') {
            this.loadDays();
        }
    }

    Warn(s: string) {
        this.$q.notify(WarnMessage(s))
    }

    CreateWidget() {
        if (this.WidgetValid()) {
            this.createDialog = true;
        }
    }

    WidgetValid(warn: boolean = true) {
        if (this.options == null) {
            if (warn)
                this.Warn('Options not defined')
            return false;
        }
        if (this.time.start < 0) {
            if (warn)
                this.Warn('Start time cannot be negative')
            return false;
        }
        if (this.time.amount < 0) {
            if (warn)
                this.Warn('Time span cannot be negative')
            return false;
        }
        if (this.options?.workerId == '') {
            if (warn)
                this.Warn('Please choose a worker')
            return false;
        }
        if (this.options?.type as any == '') {
            if (warn)
                this.Warn('Please choose chart type')
            return false;
        }
        if (this.options?.subId == '') {
            if (warn)
                this.Warn('Please choose a subcontractor')
            return false;
        }
        if (this.options?.projectId == '') {
            if (warn)
                this.Warn('Please choose a project')
            return false;
        }
        return true;
    }

    async AddWidget(name: string) {


        const id = uid();
        const w: WorkerChartWidget = {
            floorId: this.options?.floorId,
            options: DeepClone(this.options!),
            setting: DeepClone(this.GraphSettings.StoreValue),
            time: this.time,
        }
        const cw = ChartWidget.Worker(w);
        const data = WidgetData.Chart(cw);
        const widget: Widget = {
            name,
            id,
            widget: data
        }
        const r = await this.widgetStore.AddWidget(widget);
        if (r.isSome()) {
            this.Wrap.SubmitError(r.unwrap())
            return;
        } else {
            await this.$router.push(`/?add=${id}`);
        }
    }

    get Opts(): WorkerGraphOption | null {
        if (this.options == null) return null;
        if (!this.WidgetValid(false)) return null;
        const [startTime, endTime] = ToStartEnd(this.time, new Date());
        return {
            ...this.options,
            startTime,
            endTime,
        }
    }

    get Floor(): FloorPrincipalResponse | null {
        return this.floors.Find(x => x.id === this.options?.floorId);
    }


    get Wrap(): DocumentWrapper {
        return this.$refs.wrap as any;
    }

    days: string[] = []

    destroyed() {
        this.Store.StoreValue.filter = '';
        this.Store.StoreValue.rightIcon = '';
    }

    async loadDays() {
        this.Store.StoreValue.filter = 'graph';
        this.Store.StoreValue.rightIcon = 'tune';
        const token = await this.$auth.AnalyticsToken;
        const pid = this.PersistentStore.StoreValue.project;
        const dayR = await this.$analyticsApi.Get<string[]>(`Analytics/${pid}/Worker/${this.options?.workerId}/days`, null, token);

        if (dayR.isOk()) {
            const unwrapped = dayR.unwrap();
            this.days = unwrapped.Map(x => format(new Date(x), "yyyy/MM/dd"));

        }
    }


    async created() {
        await this.loadFloors();
    }

    async loadFloors() {
        const p = this;
        const t = await this.$auth.CoreToken;
        const r = await this.$coreApi.Get<FloorPrincipalResponse[]>(`Floor?projectId=${this.PersistentStore.StoreValue.project}`, null, t);
        r.match({
            err: (e) => {
                p.Wrap.SubmitError(e);
            },
            ok: (o) => {
                p.floors = o;
            }
        })

    }
}
</script>

<style lang='scss' scoped>

</style>
